<?php
/**
 * Clase Base FN para BaseCrCovid19detalleFN
 *
 * @package    
 * @subpackage BaseCrCovid19detalleFN
 * @author     Willy
 * @version    SVN:: BaseCrCovid19detalleFN.class.php,v 1.1 2020-04-15 14:49:00 william.taype Exp $
 */
class BaseCrCovid19detalleFN extends CrCovid19detalleBN
{
  private static $fieldNames = array (
    'Idsucursal'=>'idsucursal', 'Idmercado'=>'idmercado', 'Idprestamo'=>'idprestamo', 'Fechavencimientoanterior'=>'fechavencimientoanterior', 'Fechavencimientonuevo'=>'fechavencimientonuevo', 'Diasdiferencia'=>'diasdiferencia', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, idmercado, idprestamo, fechavencimientoanterior, fechavencimientonuevo, diasdiferencia, fecharegistro, usuarioregistro FROM cr_covid19detalle WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, idmercado, idprestamo, fechavencimientoanterior, fechavencimientonuevo, diasdiferencia, fecharegistro, usuarioregistro FROM cr_covid19detalle WHERE 1 ".$where;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getIdmercado()){ $where .= " AND idmercado = '".$this->getIdmercado()."'"; }
      if($this->getIdprestamo()){ $where .= " AND idprestamo = '".$this->getIdprestamo()."'"; }
      if($this->getFechavencimientoanterior()){ $where .= " AND fechavencimientoanterior = '".$this->getFechavencimientoanterior()."'"; }
      if($this->getFechavencimientonuevo()){ $where .= " AND fechavencimientonuevo = '".$this->getFechavencimientonuevo()."'"; }
      if($this->getDiasdiferencia()){ $where .= " AND diasdiferencia = '".$this->getDiasdiferencia()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, idmercado, idprestamo, fechavencimientoanterior, fechavencimientonuevo, diasdiferencia, fecharegistro, usuarioregistro FROM cr_covid19detalle WHERE 1 AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idprestamo='".$this->getIdprestamo()."'; ";
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCovid19detalleFN = new BaseCrCovid19detalleFN();
    $o_BaseCrCovid19detalleFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseCrCovid19detalleFN->setIdmercado($o_propel->idmercado);
    $o_BaseCrCovid19detalleFN->setIdprestamo($o_propel->idprestamo);
    $o_BaseCrCovid19detalleFN->setFechavencimientoanterior($o_propel->fechavencimientoanterior);
    $o_BaseCrCovid19detalleFN->setFechavencimientonuevo($o_propel->fechavencimientonuevo);
    $o_BaseCrCovid19detalleFN->setDiasdiferencia($o_propel->diasdiferencia);
    $o_BaseCrCovid19detalleFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseCrCovid19detalleFN->setUsuarioregistro($o_propel->usuarioregistro);
    return $o_BaseCrCovid19detalleFN;
  }
}